//+--------------------------------------------------+
//|PipMaker v5 Neo Last Update 06-27-2007 01:05am    |
//+--------------------------------------------------+

#include <stdlib.mqh>
#include <stderror.mqh>

#define  NL    "\n"

// Regular variables
//extern bool    AverageDown           = false;
extern int     AverageDown             = 0;
extern double  LotSize                 = 0.01;
extern double  LotIncrement            = 1.01;
//extern bool    Multiplier            = true;
extern int     Multiplier              = 0;
extern double  TargetReducer           = 0.75;
extern int     ProfitTarget            = 50;
//extern bool    OpenOnTick            = false;
extern int     OpenOnTick              = 0;
extern int     Spacing                 = 2;
extern int     TrendSpacing            = 1;
extern double  CounterTrendMultiplier  = 2;
extern double  CloseDelay              = 91;
extern int     TrendTimeFrame          = PERIOD_M1;
extern int     TrendPeriods            = 1200;
extern bool    CeaseTrading            = false;

// Internal settings
int            Step           = 1;
int            Error          = 0;
int            Order          = 0;
int            Orders         = 1;
int            Slippage       = 0;
int            Reference      = 0;
string         TradeComment   = "PipMaker v5 Neo";
datetime       BarTime        = 0;
static bool    TradeAllowed   = true;
double         TickPrice      = 0;

int            MaxBuys        = 0;
int            MaxSells       = 0;

bool           Auditing       = true;
bool           CloseOrdrs     = false;
string         Filename       = "PipMaker.txt";

int init()
{
   if (Symbol() == "AUDCADm" || Symbol() == "AUDCAD") Reference = 801001;
   if (Symbol() == "AUDJPYm" || Symbol() == "AUDJPY") Reference = 801002;
   if (Symbol() == "AUDNZDm" || Symbol() == "AUDNZD") Reference = 801003;
   if (Symbol() == "AUDUSDm" || Symbol() == "AUDUSD") Reference = 801004;
   if (Symbol() == "CHFJPYm" || Symbol() == "CHFJPY") Reference = 801005;
   if (Symbol() == "EURAUDm" || Symbol() == "EURAUD") Reference = 801006;
   if (Symbol() == "EURCADm" || Symbol() == "EURCAD") Reference = 801007;
   if (Symbol() == "EURCHFm" || Symbol() == "EURCHF") Reference = 801008;
   if (Symbol() == "EURGBPm" || Symbol() == "EURGBP") Reference = 801009;
   if (Symbol() == "EURJPYm" || Symbol() == "EURJPY") Reference = 801010;
   if (Symbol() == "EURUSDm" || Symbol() == "EURUSD") Reference = 801011;
   if (Symbol() == "GBPCHFm" || Symbol() == "GBPCHF") Reference = 801012;
   if (Symbol() == "GBPJPYm" || Symbol() == "GBPJPY") Reference = 801013;
   if (Symbol() == "GBPUSDm" || Symbol() == "GBPUSD") Reference = 801014;
   if (Symbol() == "NZDJPYm" || Symbol() == "NZDJPY") Reference = 801015;
   if (Symbol() == "NZDUSDm" || Symbol() == "NZDUSD") Reference = 801016;
   if (Symbol() == "USDCHFm" || Symbol() == "USDCHF") Reference = 801017;
   if (Symbol() == "USDJPYm" || Symbol() == "USDJPY") Reference = 801018;
   if (Symbol() == "USDCADm" || Symbol() == "USDCAD") Reference = 801019;
   if (Reference == 0) Reference = 801999;
   return(0);
}


int deinit()
{
return(0);

}


void CloseBuysInProfit()
{
   double BuyProfit, LastBuyTime;

   RefreshRates();
   
   for (Order = OrdersTotal() - 1; Order >= 0; Order--)
   {
      if (OrderSelect(Order, SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Reference && OrderType() == OP_BUY)
         {
      CloseOrdrs=false;
            BuyProfit = OrderProfit() + OrderSwap() + OrderCommission();
            if (OrderOpenTime() > LastBuyTime) LastBuyTime = OrderOpenTime();
            if ((IsTesting() || TimeCurrent() - LastBuyTime >= CloseDelay) && BuyProfit > 0) CloseOrdrs=OrderClose(OrderTicket(), OrderLots(), Bid, 5, Green);

            Error = GetLastError();
            if (Error != 0) Write("Error closing BUY order " + OrderTicket() + ": " + ErrorDescription(Error) + " (A" + Error + ")  Lots:" + OrderLots() + "  Bid:" + MarketInfo(OrderSymbol(), MODE_BID));
         }
      }
   }

   return;
}


void CloseSellsInProfit()
{
   double SellProfit, LastSellTime;

   RefreshRates();
   
   for (Order = OrdersTotal() - 1; Order >= 0; Order--)
   {
      if (OrderSelect(Order, SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Reference && OrderType() == OP_SELL)
         {
      CloseOrdrs=false;
            SellProfit = OrderProfit() + OrderSwap() + OrderCommission();
            if (OrderOpenTime() > LastSellTime) LastSellTime = OrderOpenTime();
            if ((IsTesting() || TimeCurrent() - LastSellTime >= CloseDelay) && SellProfit > 0) CloseOrdrs=OrderClose(OrderTicket(), OrderLots(), Ask, 5, Red);

            Error = GetLastError();
            if (Error != 0) Write("Error closing SELL order " + OrderTicket() + ": " + ErrorDescription(Error) + " (B" + Error + ")  Lots:" + OrderLots() + "  Ask:" + MarketInfo(OrderSymbol(), MODE_ASK));
         }
      }
   }

   return;
}


void PlaceBuyOrder()
{
   double BuyOrders, Lots;
   double LowestBuy = 1000, HighestBuy;
   int SendOrdrB=0;

   if (BarTime != Time[0])
   {
      BarTime = Time[0];
      TickPrice = 0;
      TradeAllowed = true;
   }

   RefreshRates();
   
   for (Order = OrdersTotal() - 1; Order >= 0; Order--)
   {
      if (OrderSelect(Order, SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Reference && OrderType() == OP_BUY)
         {
            if (OrderOpenPrice() < LowestBuy) LowestBuy = OrderOpenPrice();
            if (OrderOpenPrice() > HighestBuy) HighestBuy = OrderOpenPrice();
            BuyOrders++;
         }
      }
   }

   if (TradeAllowed)
   {
      if (Ask >= HighestBuy + (TrendSpacing * Point))
      {
//         if (Multiplier)
         if (Multiplier == 1)
            Lots = NormalizeDouble(LotSize * (MathPow(LotIncrement, BuyOrders) / Orders), 2);
         else
            Lots = NormalizeDouble(LotSize + ((LotIncrement * BuyOrders) / Orders), 2);
      }

      if (Ask <= LowestBuy - (Spacing * Point))
      {
//         if (Multiplier)
         if (Multiplier == 1)
            Lots = NormalizeDouble(LotSize * CounterTrendMultiplier * (MathPow(LotIncrement, BuyOrders) / Orders), 2);
         else
            Lots = NormalizeDouble((LotSize * CounterTrendMultiplier) + ((LotIncrement * BuyOrders) / Orders), 2);
      }

      if (Lots == 0)
      {
//         if (Multiplier) 
         if (Multiplier == 1)
            Lots = NormalizeDouble(LotSize * CounterTrendMultiplier, 2);
         else
            Lots = NormalizeDouble(LotSize, 2);
      }
      
      SendOrdrB=OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, 0, 0, TradeComment, Reference, Green);

      Error = GetLastError();
      if (Error != 0)
         Write("Error opening BUY order: " + ErrorDescription(Error) + " (C" + Error + ")  Ask:" + Ask + "  Slippage:" + Slippage);
      else
      {
         TickPrice = Close[0];
         TradeAllowed = false;
      }
   }
}


void PlaceSellOrder()
{
   double SellOrders, Lots;
   double HighestSell, LowestSell = 1000;
   int SendOrdrS=0;

   if (BarTime != Time[0])
   {
      BarTime = Time[0];
      TickPrice = 0;
      TradeAllowed = true;
   }

   RefreshRates();
   
   for (Order = OrdersTotal() - 1; Order >= 0; Order--)
   {
      if (OrderSelect(Order, SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Reference && OrderType() == OP_SELL)
         {
            if (OrderOpenPrice() > HighestSell) HighestSell = OrderOpenPrice();
            if (OrderOpenPrice() < LowestSell) LowestSell = OrderOpenPrice();
            SellOrders++;
         }
      }
   }

   if (TradeAllowed)
   {
      if (Bid <= LowestSell - (TrendSpacing * Point))
      {
//         if (Multiplier)
         if (Multiplier == 1)
            Lots = NormalizeDouble(LotSize * (MathPow(LotIncrement, SellOrders) / Orders), 2);
         else
            Lots = NormalizeDouble(LotSize + ((LotIncrement * SellOrders) / Orders), 2);
      }
      
      if (Bid >= HighestSell + (Spacing * Point))
      {
//         if (Multiplier)
         if (Multiplier == 1)
            Lots = NormalizeDouble(LotSize * CounterTrendMultiplier * (MathPow(LotIncrement, SellOrders) / Orders), 2);
         else
            Lots = NormalizeDouble((LotSize * CounterTrendMultiplier) + ((LotIncrement * SellOrders) / Orders), 2);
      }

      if (Lots == 0)
      {
//         if (Multiplier) 
         if (Multiplier == 1)
            Lots = NormalizeDouble(LotSize * CounterTrendMultiplier, 2);
         else
            Lots = NormalizeDouble(LotSize, 2);
      }


      SendOrdrS=OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, 0, 0, TradeComment, Reference, Red);

      Error = GetLastError();
      if (Error != 0)
         Write("Error opening SELL order: " + ErrorDescription(Error) + " (D" + Error + ")  Bid:" + Bid + "  Slippage:" + Slippage);
      else
      {
         TickPrice = Close[0];
         TradeAllowed = false;
      }
   }
}


int start()
{
   double         MarginPercent;
   static double  LowMarginPercent = 10000000, LowEquity = 10000000;
   double         BuyPipTarget, SellPipTarget;
   int            SellOrders, BuyOrders;
   double         BuyLots, SellLots;
   double         LowestBuy = 999, HighestBuy = 0.0001, LowestSell = 999, HighestSell = 0.0001, HighPoint, MidPoint, LowPoint;
   double         Profit = 0, BuyProfit = 0, SellProfit = 0, PosBuyProfit = 0, PosSellProfit = 0;
   int            HighestBuyTicket, LowestBuyTicket, HighestSellTicket, LowestSellTicket;
   double         HighestBuyProfit, LowestBuyProfit, HighestSellProfit, LowestSellProfit;
   double         CurrentTime = (TimeHour(CurTime() + TimeMinute(CurTime())));
   double         Trend;
   bool           SELLme = false;
   bool           BUYme = false;
   double         Margin = MarketInfo(Symbol(), MODE_MARGINREQUIRED);
   string         Message;

   for (Order = OrdersTotal() - 1; Order >= 0; Order--)
   {
      if (OrderSelect(Order, SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Reference)
         {
            Profit = OrderProfit() + OrderSwap() + OrderCommission();
            
            if (OrderType() == OP_BUY)
            {
               if (OrderOpenPrice() >= HighestBuy)
               {
                  HighestBuy = OrderOpenPrice();
                  HighestBuyTicket = OrderTicket();
                  HighestBuyProfit = Profit;
               }

               if (OrderOpenPrice() <= LowestBuy)
               {
                  LowestBuy = OrderOpenPrice();
                  LowestBuyTicket = OrderTicket();
                  LowestBuyProfit = Profit;
               }

               BuyOrders++;
               if (BuyOrders > MaxBuys) MaxBuys = BuyOrders;
               BuyLots += OrderLots();

               BuyProfit += Profit;
               if (Profit > 0) PosBuyProfit += Profit;
            }

            if (OrderType() == OP_SELL)
            {
               if (OrderOpenPrice() <= LowestSell)
               {
                  LowestSell = OrderOpenPrice();
                  LowestSellTicket = OrderTicket();
                  LowestSellProfit = Profit;
               }

               if (OrderOpenPrice() >= HighestSell)
               {
                  HighestSell = OrderOpenPrice();
                  HighestSellTicket = OrderTicket();
                  HighestSellProfit = Profit;
               }

               SellOrders++;
               if (SellOrders > MaxSells) MaxSells = SellOrders;
               SellLots += OrderLots();

               SellProfit += Profit;
               if (Profit > 0) PosSellProfit += Profit;
            }
         }
      }
   }

//   if (BuyOrders > 1 && Multiplier)
   if (BuyOrders > 1 && Multiplier == 1)
      BuyPipTarget = ProfitTarget * MathPow(TargetReducer, BuyOrders - 1) * Orders;
   else
      BuyPipTarget = ProfitTarget;
      
//   if (SellOrders > 1 && Multiplier)
   if (SellOrders > 1 && Multiplier == 1)
      SellPipTarget = ProfitTarget * MathPow(TargetReducer, SellOrders - 1) * Orders;
   else
      SellPipTarget = ProfitTarget;

   if (HighestBuy >= HighestSell)
      HighPoint = HighestBuy;
   else
      HighPoint = HighestSell;

   if (LowestBuy <= LowestSell)
      LowPoint = LowestBuy;
   else
      LowPoint = LowestSell;

   MidPoint = (HighPoint + LowPoint) / 2;

//   if ((SellOrders > 1 && BuyOrders > 0) || (SellOrders > 0 && BuyOrders > 1)) MidPoint = (HighPoint + LowPoint) / 2;

   RefreshRates();

   if (MidPoint > 0 && Ask - Bid > MidPoint)
   {
      if (PosBuyProfit + LowestSellProfit >= ProfitTarget && LowestSell < LowestBuy)
      {
         if(OrderSelect(LowestSellTicket, SELECT_BY_TICKET))
         {

         Error = GetLastError();
         CloseOrdrs=false;
         if (Error != 0) Write("Error accessing SELL order " + LowestSellTicket + ": " + ErrorDescription(Error) + " (E" + Error + ")");

         CloseOrdrs=OrderClose(OrderTicket(), OrderLots(), Ask, 5, Green);

         Error = GetLastError();
         if (Error != 0) Write("Error closing SELL order " + OrderTicket() + ": " + ErrorDescription(Error) + " (F" + Error + ")  Lots:" + OrderLots() + "  Ask:" + MarketInfo(OrderSymbol(), MODE_ASK));

         CloseBuysInProfit();

         LowestBuy = 1000;
         HighestBuy = 0;
         LowestSell = 1000;
         LowestSellTicket = 0;
      }
      }
      else if (PosSellProfit + LowestSellProfit >= ProfitTarget && LowestSell < LowestBuy)
      {
         if(OrderSelect(LowestSellTicket, SELECT_BY_TICKET))
         {

         Error = GetLastError();
         CloseOrdrs=false;
         if (Error != 0) Write("Error accessing SELL order " + LowestSellTicket + ": " + ErrorDescription(Error) + " (G" + Error + ")");

         CloseOrdrs=OrderClose(OrderTicket(), OrderLots(), Ask, 5, Red);

         Error = GetLastError();
         if (Error != 0) Write("Error closing SELL order " + OrderTicket() + ": " + ErrorDescription(Error) + " (H" + Error + ")  Lots:" + OrderLots() + "  Ask:" + MarketInfo(OrderSymbol(), MODE_ASK));

         CloseSellsInProfit();

         LowestSell = 1000;
         HighestSell = 0;
         LowestSellTicket = 0;
      }
      }
      else if (PosBuyProfit + LowestBuyProfit >= ProfitTarget && LowestBuy < LowestSell)
      {
         if(OrderSelect(LowestBuyTicket, SELECT_BY_TICKET))
         {

         Error = GetLastError();
         CloseOrdrs=false;
         if (Error != 0) Write("Error accessing BUY order " + LowestBuyTicket + ": " + ErrorDescription(Error) + " (I" + Error + ")");

         CloseOrdrs=OrderClose(OrderTicket(), OrderLots(), Bid, 5, Green);

         Error = GetLastError();
         if (Error != 0) Write("Error closing BUY order " + OrderTicket() + ": " + ErrorDescription(Error) + " (J" + Error + ")  Lots:" + OrderLots() + "  Bid:" + MarketInfo(OrderSymbol(), MODE_BID));

         CloseBuysInProfit();

         LowestBuy = 1000;
         HighestBuy = 0;
         LowestBuyTicket = 0;
      }
      }
      else if (PosSellProfit + LowestBuyProfit >= ProfitTarget && LowestBuy < LowestSell)
      {
         if(OrderSelect(LowestBuyTicket, SELECT_BY_TICKET))
         {

         Error = GetLastError();
         CloseOrdrs=false;
         if (Error != 0) Write("Error accessing BUY order " + LowestBuyTicket + ": " + ErrorDescription(Error) + " (K" + Error + ")");

         CloseOrdrs=OrderClose(OrderTicket(), OrderLots(), Bid, 5, Red);

         Error = GetLastError();
         if (Error != 0) Write("Error closing BUY order " + OrderTicket() + ": " + ErrorDescription(Error) + " (L" + Error + ")  Lots:" + OrderLots() + "  Bid:" + MarketInfo(OrderSymbol(), MODE_BID));

         CloseSellsInProfit();

         LowestSell = 1000;
         HighestSell = 0;
         LowestBuy = 1000;
         LowestBuyTicket = 0;
      }
      }
   }
   else if (Ask - Bid < MidPoint)
   {
      if (PosBuyProfit + HighestBuyProfit >= ProfitTarget && HighestBuy > HighestSell)
      {
         if(OrderSelect(HighestBuyTicket, SELECT_BY_TICKET))
         {

         Error = GetLastError();
         CloseOrdrs=false;
         if (Error != 0) Write("Error accessing BUY order " + HighestBuyTicket + ": " + ErrorDescription(Error) + " (M" + Error + ")");

         CloseOrdrs=OrderClose(OrderTicket(), OrderLots(), Bid, 5, Green);

         Error = GetLastError();
         if (Error != 0) Write("Error closing BUY order " + OrderTicket() + ": " + ErrorDescription(Error) + " (N" + Error + ")  Lots:" + OrderLots() + "  Bid:" + MarketInfo(OrderSymbol(), MODE_BID));

         CloseBuysInProfit();

         LowestBuy = 1000;
         HighestBuy = 0;
         HighestBuyTicket = 0;
      }
      }
      else if (PosSellProfit + HighestBuyProfit >= ProfitTarget && HighestBuy > HighestSell)
      {
         if(OrderSelect(HighestBuyTicket, SELECT_BY_TICKET))
         {

         Error = GetLastError();
         CloseOrdrs=false;
         if (Error != 0) Write("Error accessing BUY order " + HighestBuyTicket + ": " + ErrorDescription(Error) + " (O" + Error + ")");

         CloseOrdrs=OrderClose(OrderTicket(), OrderLots(), Bid, 5, Red);

         Error = GetLastError();
         if (Error != 0) Write("Error closing BUY order " + OrderTicket() + ": " + ErrorDescription(Error) + " (P" + Error + ")  Lots:" + OrderLots() + "  Bid:" + MarketInfo(OrderSymbol(), MODE_BID));

         CloseSellsInProfit();

         LowestSell = 1000;
         HighestSell = 0;
         HighestBuy = 0;
         HighestBuyTicket = 0;
      }
      }
      else if (PosBuyProfit + HighestSellProfit >= ProfitTarget && HighestSell > HighestBuy)
      {
         if(OrderSelect(HighestSellTicket, SELECT_BY_TICKET))
         {

         Error = GetLastError();
         CloseOrdrs=false;
         if (Error != 0) Write("Error accessing SELL order " + HighestSellTicket + ": " + ErrorDescription(Error) + " (Q" + Error + ")");

         CloseOrdrs=OrderClose(OrderTicket(), OrderLots(), Ask, 5, Green);

         Error = GetLastError();
         if (Error != 0) Write("Error closing SELL order " + OrderTicket() + ": " + ErrorDescription(Error) + " (R" + Error + ")  Lots:" + OrderLots() + "  Ask:" + MarketInfo(OrderSymbol(), MODE_ASK));

         CloseBuysInProfit();

         LowestBuy = 1000;
         HighestBuy = 0;
         HighestSell = 0;
         HighestSellTicket = 0;
      }
      }
      else if (PosSellProfit + HighestSellProfit >= ProfitTarget && HighestSell > HighestBuy)
      {
         if(OrderSelect(HighestSellTicket, SELECT_BY_TICKET))
         {

         Error = GetLastError();
         CloseOrdrs=false;
         if (Error != 0) Write("Error accessing SELL order " + HighestSellTicket + ": " + ErrorDescription(Error) + " (S" + Error + ")");

         CloseOrdrs=OrderClose(OrderTicket(), OrderLots(), Ask, 5, Red);

         Error = GetLastError();
         if (Error != 0) Write("Error closing SELL order " + OrderTicket() + ": " + ErrorDescription(Error) + " (T" + Error + ")  Lots:" + OrderLots() + "  Ask:" + MarketInfo(OrderSymbol(), MODE_ASK));

         CloseSellsInProfit();

         LowestSell = 1000;
         HighestSell = 0;
         HighestSellTicket = 0;
      }
      }
   }

   RefreshRates();

   Trend = iMA(Symbol(), TrendTimeFrame, TrendPeriods, 0, MODE_LWMA, PRICE_CLOSE, 0);
//   PrevTrend = iMACD(Symbol(), PERIOD_M1, 12, 26, 9, PRICE_CLOSE, MODE_MAIN, 1);
   
   // BUY Trade Criteria
   if (HighestBuy > 0 && LowestBuy < 1000)
   {
      if (Ask <= LowestBuy - (Spacing * Point) || Ask >= HighestBuy + (TrendSpacing * Point))
      {
         BUYme = true;
//          if (OpenOnTick && TickPrice > 0 && Close[0] < TickPrice) TradeAllowed = true;
         if (OpenOnTick == 1 && TickPrice > 0 && Close[0] < TickPrice) TradeAllowed = true;
      }
      if (CeaseTrading && BuyOrders == 0) BUYme = false;
      if (Ask < Trend) BUYme = false;
      if (BUYme) PlaceBuyOrder();
   }

   // SELL Trade Criteria
   if (HighestSell > 0 && LowestSell < 1000)
   {
      if (Bid >= HighestSell + (Spacing * Point) || Bid <= LowestSell - (TrendSpacing * Point))
      {
         SELLme = true;
//          if (OpenOnTick && TickPrice > 0 && Close[0] > TickPrice) TradeAllowed = true;
         if (OpenOnTick == 1 && TickPrice > 0 && Close[0] > TickPrice) TradeAllowed = true;
      }
      if (CeaseTrading && SellOrders == 0) SELLme = false;
      if (Bid > Trend) SELLme = false;
      if (SELLme) PlaceSellOrder();
   }

   if(AccountMargin()>0) MarginPercent = MathRound((AccountEquity() / AccountMargin()) * 100);

   if (LowMarginPercent > MarginPercent) LowMarginPercent = MarginPercent;
   if (AccountEquity() < LowEquity) LowEquity = AccountEquity();

   Message = "                    PipMaker v5 Neo" + NL +
             "                            ProfitTarget           " + DoubleToStr(BuyPipTarget, 2) + NL +
             "                            Buys                    " + BuyOrders + "  Highest: " + MaxBuys + NL +
             "                            BuyLots                " + DoubleToStr(BuyLots, 2) + NL +
             "                            BuyProfit              " + DoubleToStr(BuyProfit, 2) + NL +
             "                            Highest Buy           " + DoubleToStr(HighestBuy, Digits) + "  Profit: " + DoubleToStr(HighestBuyProfit, 2) + NL +
             "                            Lowest Buy            " + DoubleToStr(LowestBuy, Digits) + "  Profit: " + DoubleToStr(LowestBuyProfit, 2) + NL + NL +
             "                            ProfitTarget           " + DoubleToStr(SellPipTarget, 2) + NL +
             "                            Sells                     " + SellOrders + "  Highest: " + MaxSells + NL +
             "                            SellLots                 " + DoubleToStr(SellLots, 2) + NL +
             "                            SellProfit               " + DoubleToStr(SellProfit, 2) + NL +
             "                            Highest Sell           " + DoubleToStr(HighestSell, Digits) + "  Profit: " + DoubleToStr(HighestSellProfit, 2) + NL +
             "                            Lowest Sell            " + DoubleToStr(LowestSell, Digits) + "  Profit: " + DoubleToStr(LowestSellProfit, 2) + NL + NL +
             "                            Balance                " + DoubleToStr(AccountBalance(), 2) + NL +
             "                            Equity                  " + DoubleToStr(AccountEquity(), 2) + "  Lowest: " + DoubleToStr(LowEquity, 2) + NL + NL +
             "                            Margin                  " + DoubleToStr(AccountMargin(), 2) + NL +
             "                            MarginPercent        " + DoubleToStr(MarginPercent, 2) + NL +
             "                            LowMarginPercent  " + DoubleToStr(LowMarginPercent, 2) + NL +
             "                            Current Time is      " +  TimeToStr(TimeCurrent(), TIME_SECONDS);
   Comment(Message);
   
/*
   string MarPercent = DoubleToStr(MarginPercent, 0);
   string LowMarPercent = DoubleToStr(LowMarginPercent, 0);

   string AcctBalance = DoubleToStr(AccountBalance(), 0);
   ObjectDelete("MarginPercent");

   if (ObjectFind("MarginPercent") != 0)
   {
      ObjectCreate("MarginPercent", OBJ_TEXT, 0, Time[0], Close[0]);
      ObjectSetText("MarginPercent", MarPercent + "%  " + LowMarPercent + "%  $" + AcctBalance, 24, "Arial", White);
   }
   else
   {
      ObjectMove("MarginPercent", 0, Time[0], Close[0]);
   }
*/
   if (ObjectFind("MidPoint") != 0)
   {
      ObjectCreate("MidPoint", OBJ_HLINE, 0, Time[0], MidPoint);
      ObjectSet("MidPoint", OBJPROP_COLOR, Blue);
      ObjectSet("MidPoint", OBJPROP_WIDTH, 2);
   }
   else
   {
      ObjectMove("MidPoint", 0, Time[0], MidPoint);
   }
   return(0);
}


void Write(string String)
{
   int Handle;

   if (!Auditing) return;

   Handle = FileOpen(Filename, FILE_READ|FILE_WRITE|FILE_CSV, "/t");
   if (Handle < 1)
   {
      Print("Error opening audit file: Code ", GetLastError());
      return;
   }

   if (!FileSeek(Handle, 0, SEEK_END))
   {
      Print("Error seeking end of audit file: Code ", GetLastError());
      return;
   }

   if (FileWrite(Handle, TimeToStr(CurTime(), TIME_DATE|TIME_SECONDS) + "  " + String) < 1)
   {
      Print("Error writing to audit file: Code ", GetLastError());
      return;
   }

   FileClose(Handle);
}

